// FOPVisioStencilConvert.h: interface for the CFOPVisioStencilConvert class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FOPVISIOSTENCILCONVERT_H__4FB4D40A_B025_493F_92BE_729A9B39545B__INCLUDED_)
#define AFX_FOPVISIOSTENCILCONVERT_H__4FB4D40A_B025_493F_92BE_729A9B39545B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "XDXml.h"
#include "AfxTempl.h"
#include "FODataModel.h"
#include "FOPVisioStencilHelper.h"

const CString c_strBITMAP = "Bitmap";
const CString c_strMETAFILE = "Metafile";
const int c_nHEXADECIMAL = 16;
const int c_nHTML_RGB_LENGTH = 7;
const short c_VISIO_SHAPE_TYPE_GROUP = 2;
const short c_sBBoxUprightWH = 1;
const CString c_strCONNECTION = "connection";
const int c_nROW_TYPE_MOVE_TO = 138;
const int c_nROW_TYPE_INVALID = -1;
const int c_nVISIO_SECTION_FIRST_COMPONENT = 10;
const int c_nVISIO_ROW_VERTEX = 1;
const int c_nVISIO_COMP_NO_SHOW = 2;
const int c_nVISIO_ROW_COMPONENT = 0;
const CString c_strFOREIGN = "foreign";


typedef CMap<int,int,CString,CString> CMapIntToString;
typedef CMap<int,int,COLORREF,COLORREF> CMapIntToColor;
typedef CMap<int,int,HelperFillStyle*,HelperFillStyle*> CMapIntToFillStyle;
typedef CMap<int,int,HelperLineStyle*,HelperLineStyle*> CMapIntToLineStyle;
typedef CMap<int,int,HelperTextStyle*,HelperTextStyle*> CMapIntToTextStyle;
typedef CMap<int,int,HelperCharStyle*,HelperCharStyle*> CMapIntToCharStyle;
typedef CMap<int,int,HelperParaStyle*,HelperParaStyle*> CMapIntToParaStyle;

typedef CArray<CXDXmlNode*,CXDXmlNode*> CArrayXDXmlNode;

 
//===========================================================================
// Summary:
//      To use a CFOPConceptStencilConvert object, just call the constructor.
//      F O P Concept Stencil Convert
//===========================================================================

class CFOPConceptStencilConvert  
{
public:
 
	// m_pModel, This member maintains a pointer to the object CFODataModel.  
	CFODataModel* m_pModel;
 
	// Microsoft Visio style Shapes, This member specify E-XD++ CFODrawShapeSet object.  
	CFODrawShapeSet	m_setVisioShapes;
	
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Convert M M2 Point_ Horizontal, None Description.
	//		Returns a int type value.  
	// Parameters:
	//		dHorz---dHorz, Specifies a double dHorz object.
	int ConvertMM2Point_Horz(double dHorz);
	
	//-----------------------------------------------------------------------
	// Summary:
	// Convert M M2 Point_ Vertical, None Description.
	//		Returns a int type value.  
	// Parameters:
	//		dHorz---dHorz, Specifies a double dHorz object.
	int ConvertMM2Point_Vert(double dHorz);
	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Rotation Angle, Returns the specified value.
	//		Returns a float value.  
	// Parameters:
	//		dAngle---dAngle, Specifies a double dAngle object.
	float GetRotationAngle(double dAngle);
	
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// F O P Concept Stencil Convert, Constructs a CFOPConceptStencilConvert object.
	//		Returns A  value.  
	// Parameters:
	//		pModel---pModel, A pointer to the CFODataModel or NULL if the call failed.  
	//		strConceptFile---Concept File, Specifies A CString type value.
	CFOPConceptStencilConvert(CFODataModel* pModel, CString strConceptFile)
		: m_pModel(pModel), m_strConceptFile(strConceptFile), m_bTopShape(false) { }
	
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Convert, None Description.

	void Convert();
	
	//-----------------------------------------------------------------------
	// Summary:
	// Dispose, None Description.

	void Dispose();
	
private:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Xml Document, Call the Process member function to translate a caught exception.

	void ProcessXmlDocument();
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Pages, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodePages---nodePages, Specifies a CXDXmlNode nodePages object.
	void ProcessPages(CXDXmlNode nodePages);
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Page, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodePage---nodePage, Specifies a CXDXmlNode nodePage object.
	void ProcessPage(CXDXmlNode nodePage);
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Shapes, Call the Process member function to translate a caught exception.
	// Parameters:
	//		node---Specifies a CXDXmlNode node object.  
	//		*pParent---*pParent, A pointer to the Group  or NULL if the call failed.  
	//		&masterInfo---&masterInfo, Specifies a E-XD++ CFOPMasterInfo &masterInfo object.
	void ProcessShapes(CXDXmlNode node, Group *pParent, CFOPMasterInfo &masterInfo);
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Shape, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeShapeList---Shape List, Specifies a CXDXmlNode nodeShapeList object.  
	//		*pParent---*pParent, A pointer to the Group  or NULL if the call failed.  
	//		&masterInfo---&masterInfo, Specifies a E-XD++ CFOPMasterInfo &masterInfo object.
	void ProcessShape(CXDXmlNode nodeShapeList, Group *pParent, CFOPMasterInfo &masterInfo);
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Geom, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeGeom---nodeGeom, Specifies a CXDXmlNode nodeGeom object.  
	//		&masterInfo---&masterInfo, Specifies a E-XD++ CFOPMasterInfo &masterInfo object.
	void ProcessGeom(CXDXmlNode nodeGeom, CFOPMasterInfo &masterInfo);
	
	
private:
 
	// X M L, This member specify CXDXml object.  
	CXDXml m_fopXML;
 
	// Concept File, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_strConceptFile;
	
 
	// Top Shape, Specify A Boolean value.  
	bool m_bTopShape;
};

 
//===========================================================================
// Summary:
//      To use a CFOPVisioStencilConvert object, just call the constructor.
//      F O P Microsoft Visio style Stencil Convert
//===========================================================================

class CFOPVisioStencilConvert  
{
public:
 
	// m_pModel, This member maintains a pointer to the object CFODataModel.  
	CFODataModel* m_pModel;
 
	// Microsoft Visio style Shapes, This member specify E-XD++ CFODrawShapeSet object.  
	CFODrawShapeSet	m_setVisioShapes;

public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Convert M M2 Point_ Horizontal, None Description.
	//		Returns a int type value.  
	// Parameters:
	//		dHorz---dHorz, Specifies a double dHorz object.
	int ConvertMM2Point_Horz(double dHorz);
	
	//-----------------------------------------------------------------------
	// Summary:
	// Convert M M2 Point_ Vertical, None Description.
	//		Returns a int type value.  
	// Parameters:
	//		dHorz---dHorz, Specifies a double dHorz object.
	int ConvertMM2Point_Vert(double dHorz);
	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Rotation Angle, Returns the specified value.
	//		Returns a float value.  
	// Parameters:
	//		dAngle---dAngle, Specifies a double dAngle object.
	float GetRotationAngle(double dAngle);

public:
 
	// Convert File, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_strConvertFile;
 
	// Temp Directory, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_strTempDir;
 
	// Temp Vsx File, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_strTempVsxFile;
 
	// Vss File Name, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_strVssFileName;
	
 
	// Main Shape, Specify A Boolean value.  
	bool m_bMainShape;
 
	// Y Center, This member specify The float keyword designates a 32-bit floating-point number.  
	float fYCenter;
 
	// X Center, This member specify The float keyword designates a 32-bit floating-point number.  
	float fXCenter;
	
 
	// m_nodeTemp, This member specify Node object.  
	Node m_nodeTemp;
	
 
	// Palette Temp, This member maintains a pointer to the object SymbolPalette.  
	SymbolPalette *m_pPaletteTemp ;
 
	// Symbol Palette Name, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_strSymbolPaletteName;
 
	// Symbol Temp, This member maintains a pointer to the object Group.  
	Group *m_pSymbolTemp;
 
	// Top Shape, Specify A Boolean value.  
	bool m_bTopShape;
 
	// Ignore Styles, Specify A Boolean value.  
	bool m_bIgnoreStyles;

public:
 
	// X M L, This member specify CXDXml object.  
	CXDXml m_fopXML;
 
	// Face Names, This member specify CMapIntToString object.  
	CMapIntToString m_hashFaceNames;
 
	// m_hashColors, This member specify CMapIntToColor object.  
	CMapIntToColor m_hashColors;
	
 
	// Fill Style, This member specify CMapIntToFillStyle object.  
	CMapIntToFillStyle m_hashFillStyle;
 
	// Para Style, This member specify CMapIntToParaStyle object.  
	CMapIntToParaStyle m_hashParaStyle;
 
	// Line Style, This member specify CMapIntToLineStyle object.  
	CMapIntToLineStyle m_hashLineStyle;
 
	// Char Style, This member specify CMapIntToCharStyle object.  
	CMapIntToCharStyle m_hashCharStyle;
 
	// Text Style, This member specify CMapIntToTextStyle object.  
	CMapIntToTextStyle m_hashTextStyle;
	
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// F O P Microsoft Visio style Stencil Convert, Constructs a CFOPVisioStencilConvert object.
	//		Returns A  value.  
	// Parameters:
	//		pModel---pModel, A pointer to the CFODataModel or NULL if the call failed.
	CFOPVisioStencilConvert(CFODataModel* pModel) : m_pModel(pModel)
	{
		m_setVisioShapes.RemoveAll();
		m_bTopShape = false;
		m_bMainShape = false;
		m_strSymbolPaletteName = _T("no name");
	}
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// F O P Microsoft Visio style Stencil Convert, Constructs a CFOPVisioStencilConvert object.
	//		Returns A  value.  
	// Parameters:
	//		pModel---pModel, A pointer to the CFODataModel or NULL if the call failed.  
	//		strFileName---File Name, Specifies A CString type value.  
	//		ignoreStyles---ignoreStyles, Specifies A Boolean value.
	CFOPVisioStencilConvert(CFODataModel* pModel, CString strFileName, bool ignoreStyles) : m_pModel(pModel)
	{
		m_setVisioShapes.RemoveAll();
		m_bTopShape = false;
		m_bMainShape = false;
		m_strSymbolPaletteName = _T("no name");
		m_strConvertFile = strFileName;
		m_bIgnoreStyles = ignoreStyles;
	}

	
	//-----------------------------------------------------------------------
	// Summary:
	// F O P Microsoft Visio style Stencil Convert, Constructs a CFOPVisioStencilConvert object.
	//		Returns A  value.  
	// Parameters:
	//		pModel---pModel, A pointer to the CFODataModel or NULL if the call failed.  
	//		strFileName---File Name, Specifies A CString type value.  
	//		strTempDir---Temp Directory, Specifies A CString type value.  
	//		ignoreStyles---ignoreStyles, Specifies A Boolean value.
	CFOPVisioStencilConvert(CFODataModel* pModel, CString strFileName, CString strTempDir, bool ignoreStyles) : m_pModel(pModel)
	{
		m_setVisioShapes.RemoveAll();
		m_bTopShape = false;
		m_bMainShape = false;
		m_strSymbolPaletteName = _T("no name");
		m_strConvertFile = strFileName;
		m_strTempDir = strTempDir;
		m_bIgnoreStyles = ignoreStyles;
	}

	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Xml Document, Call the Process member function to translate a caught exception.

	void ProcessXmlDocument();
	
	//-----------------------------------------------------------------------
	// Summary:
	// Create Symbol Palette, You construct a CFOPVisioStencilConvert object in two steps. First call the constructor, then call Create, which creates the object.

	void CreateSymbolPalette();

	
	//-----------------------------------------------------------------------
	// Summary:
	// Internal Convert, None Description.

	void InternalConvert();

public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Convert, None Description.

	void Convert();
	
	//-----------------------------------------------------------------------
	// Summary:
	// Dispose, None Description.

	void Dispose();
	
private:	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Face Names, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeFaceNames---Face Names, Specifies a CXDXmlNode nodeFaceNames object.
	void ProcessFaceNames(CXDXmlNode nodeFaceNames);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Colors, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeColors---nodeColors, Specifies a CXDXmlNode nodeColors object.
	void ProcessColors(CXDXmlNode nodeColors);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Style Sheets, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeStyleSheets---Style Sheets, Specifies a CXDXmlNode nodeStyleSheets object.
	void ProcessStyleSheets(CXDXmlNode nodeStyleSheets);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Style Sheet, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeStyleSheet---Style Sheet, Specifies a CXDXmlNode nodeStyleSheet object.
	void ProcessStyleSheet(CXDXmlNode nodeStyleSheet);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Para Node, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodePara---nodePara, Specifies a CXDXmlNode nodePara object.  
	//		*hlpParaStyle---Para Style, A pointer to the HelperParaStyle  or NULL if the call failed.
	void ProcessParaNode(CXDXmlNode nodePara, HelperParaStyle *hlpParaStyle);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Char Node, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeChar---nodeChar, Specifies a CXDXmlNode nodeChar object.  
	//		*hlpCharStyle---Char Style, A pointer to the HelperCharStyle  or NULL if the call failed.
	void ProcessCharNode(CXDXmlNode nodeChar, HelperCharStyle *hlpCharStyle);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Text Node, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeText---nodeText, Specifies a CXDXmlNode nodeText object.  
	//		*hlpTextStyle---Text Style, A pointer to the HelperTextStyle  or NULL if the call failed.
	void ProcessTextNode(CXDXmlNode nodeText, HelperTextStyle *hlpTextStyle);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Line Node, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeLine---nodeLine, Specifies a CXDXmlNode nodeLine object.  
	//		*hlpLineStyle---Line Style, A pointer to the HelperLineStyle  or NULL if the call failed.
	void ProcessLineNode(CXDXmlNode nodeLine, HelperLineStyle *hlpLineStyle);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Fill Node, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeFill---nodeFill, Specifies a CXDXmlNode nodeFill object.  
	//		*hlpFillStyle---Fill Style, A pointer to the HelperFillStyle  or NULL if the call failed.
	void ProcessFillNode(CXDXmlNode nodeFill, HelperFillStyle *hlpFillStyle);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Document Props, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeDocProps---Document Props, Specifies a CXDXmlNode nodeDocProps object.
	void ProcessDocProps(CXDXmlNode nodeDocProps);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Masters, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeMasters---nodeMasters, Specifies a CXDXmlNode nodeMasters object.
	void ProcessMasters(CXDXmlNode nodeMasters);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Master, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeMaster---nodeMaster, Specifies a CXDXmlNode nodeMaster object.
	void ProcessMaster(CXDXmlNode nodeMaster);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Shapes, Call the Process member function to translate a caught exception.
	// Parameters:
	//		node---Specifies a CXDXmlNode node object.  
	//		*pParent---*pParent, A pointer to the Group  or NULL if the call failed.  
	//		&masterInfo---&masterInfo, Specifies a E-XD++ CFOPMasterInfo &masterInfo object.
	void ProcessShapes(CXDXmlNode node, Group *pParent, CFOPMasterInfo &masterInfo);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Shape, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeShapeList---Shape List, Specifies a CXDXmlNode nodeShapeList object.  
	//		*pParent---*pParent, A pointer to the Group  or NULL if the call failed.  
	//		&masterInfo---&masterInfo, Specifies a E-XD++ CFOPMasterInfo &masterInfo object.
	void ProcessShape(CXDXmlNode nodeShapeList, Group *pParent, CFOPMasterInfo &masterInfo);

	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Geom, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeGeom---nodeGeom, Specifies a CXDXmlNode nodeGeom object.  
	//		&masterInfo---&masterInfo, Specifies a E-XD++ CFOPMasterInfo &masterInfo object.
	void ProcessGeom(CXDXmlNode nodeGeom, CFOPMasterInfo &masterInfo);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Image Information, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeImgInfo---Img Information, Specifies a CXDXmlNode nodeImgInfo object.  
	//		fii---Specifies a ForeignImageInfo fii object.
	void ProcessImageInfo(CXDXmlNode nodeImgInfo, ForeignImageInfo fii);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process X Form, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeXForm---X Form, Specifies a CXDXmlNode nodeXForm object.  
	//		&xfShapeProp---Shape Property, Specifies a XForm &xfShapeProp object.
	void ProcessXForm(CXDXmlNode nodeXForm, XForm &xfShapeProp);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Protection, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeProtection---nodeProtection, Specifies a CXDXmlNode nodeProtection object.  
	//		*pStlEdit---Stl Edit, A pointer to the EditStyle  or NULL if the call failed.
	void ProcessProtection(CXDXmlNode nodeProtection, EditStyle *pStlEdit);
	
	// Text Processing Helpers
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Text, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeText---nodeText, Specifies a CXDXmlNode nodeText object.  
	//		&xfTextProp---Text Property, Specifies a XForm &xfTextProp object.  
	//		&xfShapeProp---Shape Property, Specifies a XForm &xfShapeProp object.
	void ProcessText(CXDXmlNode nodeText, XForm &xfTextProp, XForm &xfShapeProp);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Check For Node Existance, None Description.
	//		Returns A Boolean value.  
	// Parameters:
	//		nodeToSearchIn---To Search In, Specifies a CXDXmlNode nodeToSearchIn object.  
	//		strNodeNameToSearchFor---Node Name To Search For, Specifies A CString type value.
	bool CheckForNodeExistance(CXDXmlNode nodeToSearchIn, CString strNodeNameToSearchFor);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Text X Form, Call the Process member function to translate a caught exception.
	// Parameters:
	//		nodeXForm---X Form, Specifies a CXDXmlNode nodeXForm object.  
	//		&xfShapeProp---Shape Property, Specifies a XForm &xfShapeProp object.
	void ProcessTextXForm(CXDXmlNode nodeXForm, XForm &xfShapeProp);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Show Geom, Call this function to show the specify object.
	//		Returns A Boolean value.  
	// Parameters:
	//		nodeGeom---nodeGeom, Specifies a CXDXmlNode nodeGeom object.
	bool ShowGeom(CXDXmlNode nodeGeom);

	//	region Geom Processing Helper Methods
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Search For Sibling, None Description.
	//		Returns a int type value.  
	// Parameters:
	//		nodeToSearch---To Search, Specifies a CXDXmlNode nodeToSearch object.  
	//		strName---strName, Specifies A CString type value.  
	//		strAttributeName---Attribute Name, Specifies A CString type value.  
	//		nAttrValue---Attr Value, Specifies A integer value.  
	//		bCaseSensitive---Case Sensitive, Specifies A Boolean value.
	int SearchForSibling(CXDXmlNode nodeToSearch, CString strName, CString strAttributeName, int nAttrValue, bool bCaseSensitive);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Node By Name, Returns the specified value.
	//		Returns A CXDXmlNode value.  
	// Parameters:
	//		strNodeName---Node Name, Specifies A CString type value.  
	//		xmlNodeParent---Node Parent, Specifies a CXDXmlNode xmlNodeParent object.
	CXDXmlNode GetNodeByName(CString strNodeName, CXDXmlNode xmlNodeParent);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Has Bitmap Or Metafile, None Description.
	//		Returns A Boolean value.  
	// Parameters:
	//		nodeFrgnData---Frgn Data, Specifies a CXDXmlNode nodeFrgnData object.
	bool HasBitmapOrMetafile(CXDXmlNode nodeFrgnData);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Rotation Angle, Returns the specified value.
	//		Returns a float value.  
	// Parameters:
	//		nodeAngle---nodeAngle, Specifies a CXDXmlNode nodeAngle object.
	float GetRotationAngle(CXDXmlNode nodeAngle);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Value, Call the Process member function to translate a caught exception.
	//		Returns a float value.  
	// Parameters:
	//		node---Specifies a CXDXmlNode node object.  
	//		strItem---strItem, Specifies A CString type value.
	float ProcessValue(CXDXmlNode node, CString strItem);
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Process Color, Call the Process member function to translate a caught exception.
	//		Returns A 32-bit value used as a color value.  
	// Parameters:
	//		strColor---strColor, Specifies A CString type value.  
	//		bTextBlock---Text Block, Specifies A Boolean value.
	COLORREF ProcessColor(CString strColor, bool bTextBlock);

	
	//-----------------------------------------------------------------------
	// Summary:
	// Convert To Pixels, None Description.
	//		Returns a float value.  
	// Parameters:
	//		fValue---fValue, Specifies A float value.
	float ConvertToPixels(float fValue);
		
	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Attribute, Returns the specified value.
	//		Returns A Boolean value.  
	// Parameters:
	//		node---Specifies a CXDXmlNode node object.  
	//		&nValue---&nValue, Specifies A integer value.  
	//		strAttributeName---Attribute Name, Specifies A CString type value.
	bool GetAttribute(CXDXmlNode node, int &nValue, CString strAttributeName);
};

#endif // !defined(AFX_FOPVISIOSTENCILCONVERT_H__4FB4D40A_B025_493F_92BE_729A9B39545B__INCLUDED_)
