// FOPVisioStencilConverter.h: interface for the CFOPVisioStencilConverter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FOPVISIOSTENCILCONVERTER_H__D3599687_8DB7_496F_B9A8_0A8B62F06B57__INCLUDED_)
#define AFX_FOPVISIOSTENCILCONVERTER_H__D3599687_8DB7_496F_B9A8_0A8B62F06B57__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FOPSvgConvert.h"
#include "FOPVisioStencilConvert.h"

 
//===========================================================================
// Summary:
//      To use a CFOPSVGStencilConverter object, just call the constructor.
//      F O P S V G Stencil Converter
//===========================================================================

class CFOPSVGStencilConverter  
{
private:
 
	// Convert File, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_strConvertFile;
 
	// m_stencilConverter, This member specify E-XD++ CFOPSvgConvert object.  
//	CFOPSvgConvert m_stencilConverter;
	
public:
	// Creates an instance of the CFOPVisioStencilConverter.
	
	//-----------------------------------------------------------------------
	// Summary:
	// F O P S V G Stencil Converter, Constructs a CFOPSVGStencilConverter object.
	//		Returns A  value.  
	// Parameters:
	//		pModel---pModel, A pointer to the CFODataModel or NULL if the call failed.  
	//		strFileName---File Name, Specifies A CString type value.
	CFOPSVGStencilConverter(CFODataModel* pModel, CString strFileName)
	{};
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Convert, None Description.

	void Convert()
	{
	//	m_stencilConverter.Convert();
	}
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Dispose, None Description.

	// Disposes the CFOPSVGStencilConverter.
	void Dispose()
	{
	//	m_stencilConverter.Dispose();
	}
};

 
//===========================================================================
// Summary:
//      To use a CFOPConceptStencilConverter object, just call the constructor.
//      F O P Concept Stencil Converter
//===========================================================================

class CFOPConceptStencilConverter  
{
private:
 
	// Convert File, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_strConvertFile;
 
	// m_stencilConverter, This member specify E-XD++ CFOPConceptStencilConvert object.  
	CFOPConceptStencilConvert m_stencilConverter;
	
public:
	// Creates an instance of the CFOPVisioStencilConverter.
	
	//-----------------------------------------------------------------------
	// Summary:
	// F O P Concept Stencil Converter, Constructs a CFOPConceptStencilConverter object.
	//		Returns A  value.  
	// Parameters:
	//		pModel---pModel, A pointer to the CFODataModel or NULL if the call failed.  
	//		strFileName---File Name, Specifies A CString type value.
	CFOPConceptStencilConverter(CFODataModel* pModel, CString strFileName) : m_stencilConverter(pModel, strFileName) { }
	
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Convert, None Description.

	void Convert()
	{
		m_stencilConverter.Convert();
	}
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Dispose, None Description.

	// Disposes the CFOPVisioStencilConverter.
	void Dispose()
	{
		m_stencilConverter.Dispose();
	}
};

 
//===========================================================================
// Summary:
//      To use a CFOPVisioStencilConverter object, just call the constructor.
//      F O P Microsoft Visio style Stencil Converter
//===========================================================================

class CFOPVisioStencilConverter  
{
private:
 
	// Convert File, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_strConvertFile;
 
	// m_stencilConverter, This member specify E-XD++ CFOPVisioStencilConvert object.  
	CFOPVisioStencilConvert m_stencilConverter;
	
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// F O P Microsoft Visio style Stencil Converter, Constructs a CFOPVisioStencilConverter object.
	//		Returns A  value.  
	// Parameters:
	//		pModel---pModel, A pointer to the CFODataModel or NULL if the call failed.  
	//		strFileName---File Name, Specifies A CString type value.
	// Creates an instance of the CFOPVisioStencilConverter.
	CFOPVisioStencilConverter(CFODataModel* pModel, CString strFileName) : m_stencilConverter(pModel)
	{
		m_stencilConverter.m_strTempVsxFile = strFileName;
	}
	
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Convert, None Description.

	void Convert()
	{
		m_stencilConverter.Convert();
	}
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Dispose, None Description.

	// Disposes the CFOPVisioStencilConverter.
	void Dispose()
	{
		m_stencilConverter.Dispose();
	}
};

#endif // !defined(AFX_FOPVISIOSTENCILCONVERTER_H__D3599687_8DB7_496F_B9A8_0A8B62F06B57__INCLUDED_)
