// MyToolBoxBar.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MyToolBoxBar.h"
#include "ProgressWnd.h"
 
/////////////////////////////////////////////////////////////////////////////
// CMyToolBoxBar

CMyToolBoxBar::CMyToolBoxBar()
{
}

CMyToolBoxBar::~CMyToolBoxBar()
{
	POSITION pos = m_Pages.GetHeadPosition();
	while(pos != NULL)
	{
		delete m_Pages.GetNext(pos);
	}
	m_Pages.RemoveAll();
}


BEGIN_MESSAGE_MAP(CMyToolBoxBar, CDockablePane)
	//{{AFX_MSG_MAP(CMyToolBoxBar)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMyToolBoxBar message handlers

int CMyToolBoxBar::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDockablePane::OnCreate(lpCreateStruct) == -1)
		return -1;

	m_wndTool.Create(WS_CHILD|WS_VISIBLE|WS_TABSTOP|WS_EX_CLIENTEDGE,CRect(0,0,100,100),this,1232);
	
	// Do create toolbox pages.
	DoCreatePages();

	return 0;
}

void CMyToolBoxBar::DoCreatePages()
{
	LoadFromFile();	

	if(m_Pages.GetCount() <= 0)
	{
		CString strNewTitle;
		strNewTitle.LoadString(IDS_FO_NEW_TOOLBOXPAGE);
		m_wndTool.AddPage(strNewTitle);
		m_wndTool.ActivatePage(0);
	}
	else
	{
		POSITION pos = m_Pages.GetHeadPosition();
		while(pos != NULL)
		{
			CFOListItemObj *pObj = (CFOListItemObj *)m_Pages.GetNext(pos);
			CString strPathX = AfxGetApp()->m_pszHelpFilePath;
			strPathX = strPathX.Left(strPathX.ReverseFind('\\'));
			CString strOtherFile;
			strOtherFile = strPathX+_T("\\Shapes\\");
			strOtherFile += pObj->strFileName;
			CString strTitle = pObj->strFileName;
			strTitle = strTitle.Left(strTitle.GetLength() -4);
			m_wndTool.AddPage(strTitle);
			m_wndTool.GetToolBoxWnd()->LoadResFile(strOtherFile);
			m_wndTool.GetToolBoxWnd()->GetCurrentPage()->SetObjectCaption(strTitle);

		}
		
		m_wndTool.ActivatePage(0);
	}
}

void CMyToolBoxBar::OnSize(UINT nType, int cx, int cy) 
{
	CDockablePane::OnSize(nType, cx, cy);
	
	if( m_wndTool.GetSafeHwnd() != NULL )
	{
		 
		m_wndTool.SetWindowPos( NULL, -1, -1, cx, cy, SWP_NOZORDER|SWP_NOACTIVATE );
	}
}

BOOL CMyToolBoxBar::OnEraseBkgnd( CDC* pDC )
{
	CDockablePane::OnEraseBkgnd(pDC);
	return TRUE;
}

CFOListItemObj *CMyToolBoxBar::FindObjByID(int nIndex)
{
	POSITION pos = m_Pages.GetHeadPosition();
	while(pos != NULL)
	{
		CFOListItemObj *pObj = (CFOListItemObj *)m_Pages.GetNext(pos);
		if(pObj->nID == nIndex)
		{
			return pObj;
		}
	}
	return NULL;
}

void CMyToolBoxBar::LoadFromFile()
{
	CString strPathX = AfxGetApp()->m_pszHelpFilePath;
	strPathX = strPathX.Left(strPathX.ReverseFind('\\'));
	CString strOtherFile;
	strOtherFile = strPathX+_T("\\Shapes\\index.dat");
	gfxData.m_strDefToolboxFile	= _T("index.dat");
	CStdioFile m_File;
	if(m_File.Open(strOtherFile,CFile::modeRead | CFile::typeText))
	{
		CString strTemp;
		int nNumber = 100;
		while (m_File.ReadString(strTemp))
		{
			
			strTemp.TrimLeft();
			strTemp.TrimRight();
			if(!strTemp.IsEmpty())
			{
				CString strTitle;
				CString strFile;
				strTitle = strTemp.Left(strTemp.ReverseFind('#'));
				strFile = strTemp.Right(strTemp.GetLength() - strTitle.GetLength() -1);
				if((!strTitle.IsEmpty()) && (!strFile.IsEmpty()))
				{
					CFOListItemObj *pObj = new CFOListItemObj;
					pObj->strTitle = strTitle;
					pObj->strFileName = strFile;
					pObj->nID = nNumber;
					m_Pages.AddTail(pObj);
					nNumber ++;
				}
			}	
		}
		m_File.Close();
	}
}

void CMyToolBoxBar::LoadPages(const CString &strPages)
{
	CProgressWnd m_wndProgress;
	m_wndProgress.SetTitle(_T("Loading data..."));
	m_wndProgress.SetMessage(_T("This is a progress window to see how it turns out."));
	int nTotal = 50;
	m_wndProgress.SetFullScale(nTotal);
	m_wndProgress.SetCanCancelFlag(FALSE);
	m_wndProgress.SetCancelMessage(9999);
	//	m_wndProgress.SetAnimationFile("buzz.avi");
	m_wndProgress.Show(AfxGetMainWnd());

	m_wndProgress.UpdateProgress(5);

	CFOToolBoxPageArray m_Olds;
	CFOToolBoxPage *pPage = NULL;
	BOOL bNeed = FALSE;
	int nOldSize = m_wndTool.GetPages()->GetSize();
	if (nOldSize > 0)
	{
		bNeed = TRUE;
		int x = 0;
		for (x = 0; x < nOldSize; x++)
		{
			pPage = (CFOToolBoxPage *)m_wndTool.GetPages()->GetAt(x);
			m_Olds.Add(pPage);

		}

		//	m_wndTool.GetPages()->RemoveAll();

	}
	m_wndProgress.UpdateProgress(5);
	if (strPages.IsEmpty())
	{
		return;
	}

	POSITION pos = m_Pages.GetHeadPosition();
	while (pos != NULL)
	{
		delete m_Pages.GetNext(pos);
	}
	m_Pages.RemoveAll();
	m_wndProgress.UpdateProgress(5);
	CStringArray mPages;
	FOStringToStringArray(strPages, _T("@"), mPages);
	int nNumber = 100;
	for (int x1 = 0; x1 < mPages.GetSize(); x1++)
	{
		CString strPage = mPages.GetAt(x1);
		if (!strPage.IsEmpty())
		{
			CFOListItemObj *pObj = new CFOListItemObj;
			pObj->strTitle = strPage;
			pObj->strFileName = strPage;
			pObj->nID = nNumber;
			m_Pages.AddTail(pObj);
			nNumber++;
		}
	}
	m_wndProgress.UpdateProgress(5);
	if (m_Pages.GetCount() <= 0)
	{
		CString strNewTitle;
		strNewTitle.LoadString(IDS_FO_NEW_TOOLBOXPAGE);
		// Create and insert the Page
		CFOToolBoxPage* pPage = new CFOToolBoxPage;
		m_wndTool.GetPages()->Add(pPage);

		pPage->SetObjectCaption(strNewTitle);
		pPage->SetSelected(FALSE);
		m_wndTool.ReCalSetPage(0);
	}
	else
	{
		POSITION pos = m_Pages.GetHeadPosition();
		while (pos != NULL)
		{
			CFOListItemObj *pObj = (CFOListItemObj *)m_Pages.GetNext(pos);
			CString strPathX = AfxGetApp()->m_pszHelpFilePath;
			strPathX = strPathX.Left(strPathX.ReverseFind('\\'));
			CString strOtherFile;
			strOtherFile = strPathX + _T("\\Shapes\\");
			strOtherFile += pObj->strFileName;
			CString strTitle = pObj->strFileName;
			strTitle = strTitle.Left(strTitle.GetLength() - 4);
			CFOToolBoxPage* pPage = new CFOToolBoxPage;

			int nIndex = m_wndTool.GetPages()->Add(pPage);

			pPage->SetObjectCaption(strTitle);
			pPage->SetSelected(TRUE);

			// Set bar defaults
			m_wndTool.ReCalSetPage(nIndex);
			pPage->OpenDocument(strOtherFile);
			pPage->SetObjectCaption(strTitle);

		}

	}

	m_wndProgress.UpdateProgress(10);
	for (int y = 0; y < nOldSize; y++)
	{
		m_wndTool.ActivatePage(0);
		m_wndTool.RemovePage(0);

	}

	m_wndTool.ActivatePage(0);
	m_wndTool.RecalcLayout();
	m_wndTool.Invalidate(TRUE);

	gfxData.FreeObjectCache();
	CFOPPropertyExtCache::GetInstance()->ClearLoad();

	m_wndProgress.UpdateProgress(20);
	// 
	// 	if(m_wndTool.GetPages()->GetSize() >1)
	// 	{
	// 		m_wndTool.OnFoToolboxClosefile();
	// 	}
}
